#include "StdAfx.h"
#include "RichEditHelper.h"

FnNiuniu_InitGdiPlus CRichEditHelper::m_fnInitGdiPlus = NULL;
FnNiuniu_GetOleObjectPathFromPoint CRichEditHelper::m_fnGetOleObjectPathFromPoint = NULL;
FnNiuniu_PasteMsg CRichEditHelper::m_fnAddPasteMsg = NULL;
FnNiuniu_InitRichEditWnd CRichEditHelper::m_fnInitRichEditWnd = NULL;
FnNiuniu_GetRichTextContent CRichEditHelper::m_fnGetRichTextContent = NULL;
FnNiuniu_HasOleObjectFromPoint CRichEditHelper::m_fnIsOleImage = NULL;
FnNiuniu_SaveOleObjectFromPoint CRichEditHelper::m_fnSaveOleImage = NULL;

FnNiuniu_SetStartIndent CRichEditHelper::m_fnSetStartIndent = NULL;
FnNiuniu_SetSel CRichEditHelper::m_fnSetSel = NULL;
FnNiuniu_SetDefaultFont CRichEditHelper::m_fnSetDefaultFont = NULL;
FnNiuniu_ReplaceSel CRichEditHelper::m_fnReplaceSel = NULL;
FnNiuniu_InsertImage CRichEditHelper::m_fnInsertImage = NULL;
FnNiuniu_AppendMsg CRichEditHelper::m_fnAppendMsg = NULL;
FnNiuniu_GetSelText CRichEditHelper::m_fnGetSelText = NULL;
FnNiuniu_GetSel CRichEditHelper::m_fnGetSel = NULL;

HMODULE CRichEditHelper::m_hModule = NULL;

CRichEditHelper::CRichEditHelper(void)
{

}

CRichEditHelper::~CRichEditHelper(void)
{

}

int CRichEditHelper::Init()
{
	wstring strDllPath = GetCurrentPath() + _T("RichEditWrapper.dll");
	m_hModule = LoadLibraryW(strDllPath.c_str());
	DWORD dRet = GetLastError();
	m_fnInitGdiPlus = (FnNiuniu_InitGdiPlus)GetProcAddress(m_hModule, ("Niuniu_InitGdiPlus"));
	m_fnGetOleObjectPathFromPoint = (FnNiuniu_GetOleObjectPathFromPoint)GetProcAddress(m_hModule, ("Niuniu_GetOleObjectPathFromPoint"));
	m_fnAddPasteMsg = (FnNiuniu_PasteMsg)GetProcAddress(m_hModule, ("Niuniu_PasteMsg"));
	m_fnInitRichEditWnd = (FnNiuniu_InitRichEditWnd)GetProcAddress(m_hModule, ("Niuniu_InitRichEditWnd"));
	m_fnGetRichTextContent = (FnNiuniu_GetRichTextContent)GetProcAddress(m_hModule, ("Niuniu_GetRichTextContent"));
	m_fnIsOleImage = (FnNiuniu_HasOleObjectFromPoint)GetProcAddress(m_hModule, ("Niuniu_HasOleObjectFromPoint"));
	m_fnSaveOleImage = (FnNiuniu_SaveOleObjectFromPoint)GetProcAddress(m_hModule, ("Niuniu_SaveOleObjectFromPoint"));

	m_fnSetStartIndent = (FnNiuniu_SetStartIndent)GetProcAddress(m_hModule, ("Niuniu_SetStartIndent"));
	m_fnSetSel = (FnNiuniu_SetSel)GetProcAddress(m_hModule, ("Niuniu_SetSel"));
	m_fnGetSel = (FnNiuniu_GetSel)GetProcAddress(m_hModule, ("Niuniu_GetSel"));
	m_fnSetDefaultFont = (FnNiuniu_SetDefaultFont)GetProcAddress(m_hModule, ("Niuniu_SetDefaultFont"));
	m_fnReplaceSel = (FnNiuniu_ReplaceSel)GetProcAddress(m_hModule, ("Niuniu_ReplaceSel"));
	m_fnInsertImage = (FnNiuniu_InsertImage)GetProcAddress(m_hModule, ("Niuniu_InsertImage"));
	m_fnAppendMsg = (FnNiuniu_AppendMsg)GetProcAddress(m_hModule, ("Niuniu_AppendMsg"));

	m_fnGetSelText = (FnNiuniu_GetSelText)GetProcAddress(m_hModule, ("Niuniu_GetSelText"));

	m_fnInitGdiPlus();
	return 1;
}

wstring CRichEditHelper::GetCurrentPath()
{
	WCHAR wcsPath[MAX_PATH] = {0};
	GetModuleFileNameW(NULL, wcsPath, MAX_PATH);
	wstring strPath = wcsPath;
	int nPos = strPath.rfind(L'\\');
	strPath = strPath.substr(0, nPos + 1);
	return strPath;
}